#include <sys/socket.h>//consts and procedures
#include <sys/types.h>
#include <sys/time.h>  //for timeval
#include <iostream.h>
#include <string.h>    //for bzero
#include <arpa/inet.h> //for sockadd_in !!!
#include <unistd.h>    //for close() & select()
#include <conio.h>
#include <fcntl.h>     //non-blocking

#include <lsck/lsck.h>
#include <stdlib.h>

const short MYPORT = 3490;
const int   MAXCLI = 5;

#include "window.h"

char* EnterName();
void  MakeScreen();
void  ClearKeys();

char* thisname;

Window Server;
Window Clients[MAXCLI];

int   bytes_sent = 0;
int   bytes_recv = 0;
char  msg        = 0;
char  buf        = 0;
int   temp       = 0;

int   clients    = 1;

int   conn;            //Connection to server

void DisplayError() {
  cout << endl << "errno: " << errno << " -- " << lsck_strerror(errno) << endl;
}

int main(int argc, char*argv[]) {
  atexit(DisplayError);
  if (argc != 2) {
    cout << "usage: chatcli <IP Address>" << endl;
    return 99;
  }

  clrscr();
  thisname = EnterName();
  Clients[0].SetName(thisname);

  sockaddr_in dest;
  dest.sin_family = AF_INET;
  dest.sin_port = htons(MYPORT);
  dest.sin_addr.s_addr = inet_addr(argv[1]);
  bzero(dest.sin_zero, 8);

  int conn = socket(AF_INET, SOCK_STREAM, 0);
  if (conn == -1)
    return 1;

  cout << "Attempting to connect. . ." << endl;
  if (connect(conn, (sockaddr *)&dest, sizeof(sockaddr)))
    return 2;
  cout << "Connected. . ." << endl;

  buf = char(strlen(thisname));
  send(conn, &buf, 1, 0);
  temp = 0;
  while (temp < int(buf)) {
    temp += send(conn, &(thisname[temp]), buf, 0);
  }
  temp = 0;
  recv(conn, &buf, 1, 0);
  char *tempname = new char[buf+1];
  tempname[buf] = '\0';
  while (temp < int(buf)) {
    temp += recv(conn, &(tempname[temp]), buf-temp, 0);
  }
  Server.SetName(tempname);

  MakeScreen();
  ClearKeys();
  fcntl(conn, F_SETFL, O_NONBLOCK|fcntl(conn, F_GETFL));
  temp = bytes_recv = bytes_sent = 0;
  while ((msg != 27) && (buf != 27)) {
    temp = recv(conn, &buf, 1, 0);
    if (temp != -1) {
      bytes_recv += temp;
      Server << buf;
    }
    if (kbhit()) {
      msg = getch();
      Clients[0] << msg;
      bytes_sent += send(conn, &msg, 1, 0);
      if (msg == 13) //if return
        ungetch(10); //send linefeed
    }
  }
  window(1, 1, 80, 25);
  clrscr();
  cout << endl << "Total bytes recieved: " << bytes_recv;
  cout << endl << "Total bytes sent    : " << bytes_sent;

  close(conn);
  return 0;
}

char* EnterName() {
  char* ret = new char[50];
  cout << "Enter your name: ";
  cin.getline(ret, 49, '\n');
  return ret;
}

void MakeScreen() {
  int step = 24 / (clients+1);
  int pos = step;
  Server.SetPosition(1, step);
  Server.DrawWindow();
  for (int w=0; w<clients; w++) {
    Clients[w].SetPosition(pos+1, pos+step);
    Clients[w].DrawWindow();
    pos += step;
  }
}

void ClearKeys() {
  char trash;
  while (kbhit())
    trash = getch();
}
